# mkcdrec-lib.pl
# Common functions used for managing mkcdrec

#   FILE: mkcdrec-lib.cgi --
# AUTHOR: Guillaume RADDE <guillaume.radde@bull.net>
#   DATE: 22 June 2004
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use strict;
do '../web-lib.pl';
&init_config();

# no params
#this function returns a hash table containing all the parameters and their value
sub list_parameters
{	my $config_file="/var/opt/mkcdrec/Config.sh";        # the file containing the config of mkcdrec
	my %config_hash;				#the hash table that will contain all the parameters and their values
	my $editing_mod="normal";#may be "conditional" if we are reading a if, then fi statement,
				#"list" if we are reading a multiple line string
				# "normal" ortherwise
	my $current_parameter;
	my $current_value;
	my $current_comments;	# contains the comments over the current parameter
	my $line;

	open(FILE,$config_file);

	while (defined($line= <FILE>)){
		#firstly we remove comments beginning with a #
		chomp($line);
		if ($line=~ /(.*?)#(.*)$/) {
			$line=$1;
			$current_comments.=$2;
		}

		#then we look if there is no assignement in the line

		if ($editing_mod eq "list") {
			$config_hash{$current_parameter}[0].=$line."\n";
			if ($line =~ /.*"$/){
				$editing_mod="normal";
			}
			next;
		}
		if($line=~ /\s*if.*/){
			$editing_mod="conditional";
			next;
		}
		if($editing_mod eq "conditional"){
			if ($line =~ /\s*fi\s*$/){
				$editing_mod="normal";
			}
			next;

		}

		# and if there is an assignement in the line we have to store the parameter and its value

		if($line=~ /^(.*?)\=(.*)$/) {
			$current_parameter=$1;
			$current_value=$2;
			# we check if the value is a "list" or not:
			if($current_value =~ /".*"/) {					# =" toto"
				$config_hash{$current_parameter}[0]=$current_value;
			} elsif ($current_value =~ /".*/) {				# ="toto
				$editing_mod="list";
				$config_hash{$current_parameter}[0]=$current_value."\n";
			} else{								#= toto
				$config_hash{$current_parameter}[0]=$current_value;
			}
			$config_hash{$current_parameter}[1]=$current_comments;
			$current_comments="";


		}
	}

return %config_hash;
}

# save_parameter(config_file,param_name,value)
# this function save the value of a parameter in the config file
sub save_parameters {

	my($config_file,%in)=@_;
	my @tab_line;		# we will write all the line in this array beofre writing them in a file
	my $line;
	my $current_parameter;
	my $current_value;
	my $formated_current_value;
	my $current_comment;
	my $editing_mod="normal"; 	#may be "conditional" if we are reading a if, then fi statement,
							#"list" if we are reading a multiple line string
							# "normal" ortherwise
	&lock_file($config_file);
	open(FILE,$config_file);


	while (defined($line= <FILE>)){
		#firstly we remove comments beginning with a #
		chomp($line);
		if ($line=~ /(.*?)(#.*)/) {
			$line=$1;
			$current_comment=$2;
		} else {
			$current_comment="";
		}



		if ($editing_mod eq "list") {
			if ($line =~ /.*"/){
				$editing_mod="normal"
			}
			next;
		}

		if($line=~ /\s*if.*/){
			$editing_mod="conditional";
			push(@tab_line,$line.$current_comment."\n");
			next;
		}
		if($editing_mod eq "conditional"){
			if ($line =~ /\s*fi\s*$/){
				$editing_mod="normal";
			}
			push(@tab_line,$line.$current_comment."\n");
			next;

		}
		# and then we store the line in the array and change the value if the line looks like " patate=carotte "...
		if($line=~ /^(.*?)\=(.*)$/) {
			$current_parameter=$1;
			$current_value=$2;
			# we remove special characters
			$formated_current_value =$in{$current_parameter};
			$formated_current_value =~ s/\0//g;
			$formated_current_value =~ s/\r//g;
			$formated_current_value =~ s/\n+/\n/g;


			# we store the line in the array and we add the comments
			if($current_value =~ /\".*\"/) {					# =" toto"
				push(@tab_line,$current_parameter."=".$formated_current_value.$current_comment."\n");
			} elsif ($current_value =~ /\".*/) {				# ="toto
				$editing_mod="list";
				push(@tab_line,$current_parameter."=".$formated_current_value.$current_comment."\n");
			} else{
				push(@tab_line,$current_parameter."=".$formated_current_value.$current_comment."\n");
			}
		} else {
			push(@tab_line,$line.$current_comment."\n");
		}
	}
	close(FILE);
	open(FILE, ">".$config_file);
	print FILE @tab_line;
	&unlock_file($config_file);

}
